@make(ais)
@aiInfo(topic=<Need for static attributes of arrays and records>,
number=[AI-00539/00],
classcode=[ST],
statuscode=[RE],
mainref=[04.09@\(11)],
date=[87-08-05])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class study 87-08-05
!status received 87-08-05
@end(toplines)
@topic{!topic Need for static attributes of arrays and records}
@end(history)

@subheading[!summary 87-08-05]


@subheading[!question 87-08-05]


@subheading[!recommendation 87-08-05]


!wording 87-08-05


@subheading[!discussion 87-08-05]


@begin(appendix)
@subheading[!appendix 87-06-26]
@begin(sectionGroup)
@mybar()

!section 04.09    (11) Art Evans/Tartan Labs 87-06-26                83-00928
!version 1983
!topic Need for static attributes of arrays and records
@end(sectionGroup)

Ada never permits an array type to be static.  This fact follows from
the third sentence of 4.9(11).

I see no reason why a type such as

        type T is array(1..2) of integer;

should not be considered static.  In particular, I find it reasonable
that an array type be considered static if both of the following
requirements are met:

        All indices must be static ranges; and
        the array element type must be static.

(A similar rule can be developed for record types.)  If such a type is
static, it should then follow that 'size of such a type (or an object of
such a type) should be static.

This problem bit us when we tried to use the size of an array in a rep
spec, where a static value is required.

@end(appendix)
